#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six2004xi    


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six2004xi = {
                1:'-100x3y-172z',
                2:'-101x56y-163z',
                3:'-102x156y-70z',
                4:'-102x49y-164z',
                5:'-102x8y-171z',
                6:'-103x14y-170z',
                7:'-103x20y-169z',
                8:'-103x43y-165z',
                9:'-104x25y-168z',
                10:'-104x31y-167z',
                11:'-104x37y-166z',
                12:'-105x155y-67z',
                13:'-110x150y-72z',
                14:'-112x149y-69z',
                15:'-117x143y-74z',
                16:'-120x143y-71z',
                17:'-124x136y-76z',
                18:'-126x136y-73z',
                19:'-126x155y0z',
                20:'-130x129y-78z',
                21:'-133x128y-75z',
                22:'-134x148y-2z',
                23:'-136x121y-80z',
                24:'-139x121y-77z',
                25:'-13x76y-184z',
                26:'-141x141y-4z',
                27:'-142x114y-82z',
                28:'-144x113y-78z',
                29:'-147x105y-83z',
                30:'-148x133y-6z',
                31:'-152x97y-85z',
                32:'-155x125y-8z',
                33:'-156x89y-87z',
                34:'-159x80y-89z',
                35:'-161x117y-10z',
                36:'-163x71y-91z',
                37:'-165x62y-92z',
                38:'-167x108y-12z',
                39:'-167x53y-94z',
                40:'-169x44y-96z',
                41:'-170x0y-105z',
                42:'-170x35y-98z',
                43:'-171x17y-101z',
                44:'-171x26y-99z',
                45:'-171x8y-103z',
                46:'-172x99y-14z',
                47:'-177x90y-16z',
                48:'-17x142y-139z',
                49:'-17x73y-185z',
                50:'-182x80y-18z',
                51:'-185x70y-20z',
                52:'-189x60y-22z',
                53:'-191x50y-24z',
                54:'-193x40y-26z',
                55:'-195x30y-28z',
                56:'-196x20y-30z',
                57:'-197x0y-34z',
                58:'-197x9y-32z',
                59:'-1x0y-199z',
                60:'-20x70y-185z',
                61:'-21x191y-53z',
                62:'-224x157y-121z',
                63:'-23x67y-186z',
                64:'-24x139y-141z',
                65:'-25x0y-198z',
                66:'-26x64y-187z',
                67:'-27x0y-198z',
                68:'-29x2y-197z',
                69:'-29x61y-188z',
                70:'-31x136y-142z',
                71:'-31x189y-55z',
                72:'-31x4y-197z',
                73:'-31x58y-188z',
                74:'-32x6y-197z',
                75:'-33x190y-52z',
                76:'-33x55y-189z',
                77:'-34x8y-196z',
                78:'-35x10y-196z',
                79:'-35x51y-189z',
                80:'-36x48y-190z',
                81:'-37x13y-196z',
                82:'-37x44y-191z',
                83:'-38x133y-143z',
                84:'-38x15y-195z',
                85:'-38x18y-195z',
                86:'-38x41y-191z',
                87:'-39x21y-194z',
                88:'-39x37y-192z',
                89:'-40x187y-57z',
                90:'-40x24y-194z',
                91:'-40x27y-193z',
                92:'-40x31y-193z',
                93:'-40x34y-192z',
                94:'-43x187y-54z',
                95:'-44x129y-145z',
                96:'-50x184y-59z',
                97:'-51x126y-146z',
                98:'-52x184y-56z',
                99:'-57x121y-147z',
                100:'-59x180y-61z',
                101:'-5x80y-182z',
                102:'-62x117y-149z',
                103:'-62x180y-58z',
                104:'-67x112y-150z',
                105:'-68x176y-63z',
                106:'-71x176y-60z',
                107:'-72x107y-151z',
                108:'-77x102y-153z',
                109:'-77x172y-65z',
                110:'-80x172y-62z',
                111:'-81x97y-154z',
                112:'-85x91y-155z',
                113:'-86x167y-67z',
                114:'-89x167y-63z',
                115:'-89x85y-157z',
                116:'-92x80y-158z',
                117:'-94x162y-69z',
                118:'-95x74y-159z',
                119:'-97x161y-65z',
                120:'-97x68y-160z',
                121:'-99x62y-161z',
                122:'-9x78y-183z'}


#"
#/>

# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire200six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire200six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE200SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six200x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six200x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE200SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
